A5. {IFORTRAŇvZvOW

A5.1 3n̏ʒu̐ݒ (SUBROUTINE INIPOSIT)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR SETTING INITIAL POSITIONS OF PARTICLES    *
00030 C   AT CLOSED-PACKED LATTICE POINTS FOR THREE-DIMENSIONAL SYSTEM.    *
00040 C     0<RX(I)<L  ,  0<RY(I)<L  ,  0<RZ(I)<L                          * 
00050 C*********************************************************************
00060 C**** SUB INIPOSIT *****                                                
00070       SUBROUTINE INIPOSIT( N , NDENS , L )                              
00080 C                                                                       
00090       IMPLICIT REAL*8( A-H , O-Z )                                      
00100 C                                                                       
00110       COMMON /BLOCK1/ RX , RY , RZ                                      
00120 C                                                                       
00130       PARAMETER( NN=2050 , PI=3.141592653589793D0 )                     
00140 C                                                                       
00150       REAL*8  RX(NN), RY(NN), RZ(NN), NDENS , L                         
00160       INTEGER N                                                         
00170 C                                                                       
00180       REAL*8  RXI, RYI, RZI, RX0, RY0, RZ0 , C0   
00190       INTEGER Q  , K  , IX , IY , IZ  
00200 C 
00210       C0 =  ( 4.D0/NDENS )**(1./3.)                                     
00220       Q  =  IDNINT( DBLE(N/4)**(1./3.) )                                
00230       L  =  C0*DBLE(Q)                                                  
00240 C                                        --- SET INITIAL POSITIONS ---  
00250       K  =  0                                                           
00260 C                                                                       
00270       DO 100 IFACE=1,4                                                  
00280 C                                                                       
00290         IF( IFACE.EQ.1 ) THEN                                           
00300           RX0 = 0.0001D0                                                
00310           RY0 = 0.0001D0                                                
00320           RZ0 = 0.0001D0                                                
00330         ELSE IF( IFACE.EQ.2 ) THEN                                      
00340           RX0 = C0/2.D0                                                 
00350           RY0 = C0/2.D0                                                 
00360           RZ0 = 0.0001D0                                                
00370         ELSE IF( IFACE.EQ.3 ) THEN                                      
00380           RX0 = C0/2.D0                                                 
00390           RY0 = 0.0001D0                                                
00400           RZ0 = C0/2.D0                                                 
00410         ELSE IF( IFACE.EQ.4 ) THEN                                      
00420           RX0 = 0.0001D0                                                
00430           RY0 = C0/2.D0                                                 
00440           RZ0 = C0/2.D0                                                 
00450         END IF                                                          
00460 C                                                                       
00470         DO 50 IZ=0,Q-1                                                  
00480           RZI = DBLE(IZ)*C0 + RZ0                                       
00490           IF( RZI .GE. L )        GOTO 50                               
00500           DO 40 IY=0,Q-1                                                
00510             RYI = DBLE(IY)*C0 + RY0                                     
00520             IF( RYI .GE. L )      GOTO 40                               
00530             DO 30 IX=0,Q-1                                              
00540               RXI = DBLE(IX)*C0 + RX0                                   
00550               IF( RXI .GE. L )    GOTO 30                               
00560 C                                                                       
00570               K=K+1                                                     
00580               RX(K)   =  RXI                                            
00590               RY(K)   =  RYI                                            
00600               RZ(K)   =  RZI                                            
00610    30       CONTINUE                                                    
00620    40     CONTINUE                                                      
00630    50   CONTINUE                                                        
00640   100 CONTINUE                                                          
00650 C                                                                       
00660       N = K                                                             
00670       RETURN  
00680       END     


A5.2 3n̏x̐ݒ (SUBROUTINE INIVEL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR SETTING INITIAL VELOCITIES OF PARTICLES   *
00030 C   ACCORDING TO THE MAXWELLIAN DISTRIBUTION.                        *
00040 C*********************************************************************
00050 C**** SUB INIVEL ****                                                   
00060       SUBROUTINE INIVEL( N, TEMP )                                  
00070 C                                                                       
00080       IMPLICIT REAL*8( A-H , O-Z )                                      
00090 C                                                                       
00100       COMMON /BLOCK3/  VX , VY , VZ                                     
00110       COMMON /BLOCK20/ NRAN , RAN  , IX                                 
00120 C                                                                       
00130       PARAMETER( NN=2050 , NRANMX=100000 , PI=3.141592653589793D0 ) 
00140 C                                                                       
00150       INTEGER NRAN , IX                                                 
00160       REAL*8  VX(NN), VY(NN), VZ(NN)                                    
00170       REAL    RAN(NRANMX)                                               
00180 C                                                                       
00190       REAL*8  C0 , C1 , C2 , C3 , T , VCHK                              
00200 C                                                                       
00210       C0   = 2.D0*PI                                                    
00220       VCHK = 2.D0*TEMP*3.5D0**2                                         
00230       T    = TEMP*2.D0                                                  
00240 C                                                                       
00250       DO 10 I=1,N                                                       
00260 C                                                  --- X-COMPONENT ---  
00270     5   C1    = DSQRT( -T*DLOG( DBLE(RAN(NRAN)) ) )                     
00280         NRAN  = NRAN + 1                                                
00290         C1    = C1 * DSIN( C0*DBLE(RAN(NRAN)) )                         
00300         NRAN  = NRAN + 1                                                
00310 C                                                  --- Y-COMPONENT ---  
00320         C2    = DSQRT( -T*DLOG( DBLE(RAN(NRAN)) ) )                     
00330         NRAN  = NRAN + 1                                                
00340         C2    = C2 * DSIN( C0*DBLE(RAN(NRAN)) )                         
00350         NRAN  = NRAN + 1                                                
00360 C                                                  --- Z-COMPONENT ---  
00370         C3    = DSQRT( -T*DLOG( DBLE(RAN(NRAN)) ) )                     
00380         NRAN  = NRAN + 1                                                
00390         C3    = C3 * DSIN( C0*DBLE(RAN(NRAN)) )                         
00400         NRAN  = NRAN + 1                                                
00410 C                                                                       
00420         IF( (C1*C1+C2*C2+C3*C3) .GE. VCHK )   GOTO 5                    
00430         VX(I) = C1                                                      
00440         VY(I) = C2                                                      
00450         VZ(I) = C3                                                      
00460 C                                                                       
00470    10 CONTINUE                                                          
00480       RETURN  
00490       END     


A5.3 t̏̂߂3nxXP[O(SUBROUTINE SCALEVEL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR SCALING VELOCITIES OF PARTICLES TO OBTAIN *
00030 C   DESIRED TEMPERATURE AND ZERO TOTAL MOMENTUM.                     *
00040 C*********************************************************************
00050 C**** SUB SCALEVEL ****                                                 
00060       SUBROUTINE SCALEVEL( N, TEMP, VELX, VELY, VELZ, VELSQ )          
00070 C                                                                       
00080       IMPLICIT REAL*8( A-H , O-Z )                                      
00090 C                                                                       
00100       COMMON /BLOCK3/ VX     , VY     , VZ                              
00110 C                                                                       
00120       PARAMETER( NN=2050 )                                              
00130 C                                                                       
00140       REAL*8   VX(NN), VY(NN), VZ(NN),  T                               
00150 C                                                                       
00160 C                            --- ZERO TOTAL MOMENTUM FOR EACH AXIS ---  
00170       DO 70 I = 1,N                                                     
00180           VX(I) = VX(I) - VELX                                          
00190           VY(I) = VY(I) - VELY                                          
00200           VZ(I) = VZ(I) - VELZ                                          
00210    70 CONTINUE                                                          
00220 C                                --- CORRECT VELOCITIES TO SATISFY ---  
00230 C                                -   SPECIFIED TEMPERATURE           -  
00240       T = VELSQ/3.D0                                                    
00250 C                                                                       
00260       C1 = DSQRT( TEMP/T)                                              
00270 C                                                                       
00280       DO 170 I = 1,N                                                    
00290           VXI   = VX(I)                                                 
00300           VYI   = VY(I)                                                 
00310           VZI   = VZ(I)                                                 
00320           VX(I) = VXI*C1                                                
00330           VY(I) = VYI*C1                                                
00340           VZ(I) = VZI*C1                                                
00350   170 CONTINUE                                                          
00360       RETURN  
00370       END     


A5.4  (SUBROUTINE RANCAL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR GENERATING UNIFORM RANDOM NUMBERS         *
00030 C   (SINGLE PRECISION).                                              *
00040 C      N      : NUMBER OF RANDOM NUMBERS TO GENERATE                 *
00050 C      IX     : INITIAL VALUE OF RANDOM NUMBERS (POSITIVE INTEGER)   *
00060 C             : LAST GENERATED VALUE IS KEPT                         *
00070 C      X(N)   : GENERATED RANDOM NUMBERS (0<X(N)<1)                  * 
00080 C*********************************************************************
00090 C**** SUB RANCAL ****                                           
00100       SUBROUTINE RANCAL( N, IX, X )   
00110 C                                                               
00120       DIMENSION  X(N)                                           
00130       DATA INTEGMX/2147483647/                                  
00140       DATA INTEGST,INTEG/584287,48828125/                       
00150 C                                                               
00160       AINTEGMX = REAL( INTEGMX )                    
00170 C                                                               
00180       IF ( IX.LT.0 ) PAUSE  
00190       IF ( IX.EQ.0 ) IX = INTEGST                               
00200       DO 30 I=1,N                                               
00210          IX = IX*INTEG                                          
00220          IF (IX) 10, 20, 20                                    
00230    10    IX   = (IX+INTEGMX)+1                                  
00240    20    X(I) = REAL(IX)/AINTEGMX                             
00250    30 CONTINUE                                                  
00260       RETURN  
00270       END     


A5.5 ubN@(2n)

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS PART OF THE MAIN PROGRAM WHICH IS FOR            *
00030 C*  INTRODUCING THE CELL INDEX METHOD FOR TWO-DIMENSIONAL SYSTEM.    *
00040 C*********************************************************************
00050 C     GRPY(I),GRPX(I)   : GROUP TO WHICH PARTICLE I BELONGS            
00060 C     P           : NUMBER OF CUT-OFF CELLS IN EACH DIRECTION          
00070 C     TMX(GRP)    : TOTAL NUMBER OF PARTICLES BELONGING TO GROUP(GRP)  
00080 C     TABLE(*,GRP): NAME OF PARTICLE BELONGING TO GROUP(GRP)           
00090 C     GRPLX(P)    : IS USED TO DETERMINE THE CELL TO WHICH           
00100 C                   PARTICLES BELONG                             
00110 C     0<RX(I)<L  ,  0<RY(I)<L                                         
00120 C---------------------------------------------------------------------  
00130 C                                                                       
00140       IMPLICIT REAL*8 (A-H,O-Z)                                         
00150 C                                                                       
00160       COMMON /BLOCK1/  RX   , RY                                        
00170       COMMON /BLOCK3/  GRPX , GRPY                                      
00180       COMMON /BLOCK5/  TMX  , TABLE                                     
00190       COMMON /BLOCK6/  P    , GRPLX                                     
00200 C                                 --- NN : NUM. OF PARTICLES       ---  
00210 C                                 --- PP : NUM. OF CUT-OFF CELLS   ---  
00220       INTEGER  NN , PP , PP2 , TT                          
00230       PARAMETER( NN=1000 , PP=15 , PP2=225 , TT=500 )          
00240 C                                                                       
00250       REAL*8   RX(NN) , RY(NN) , GRPLX(PP) , NDENS  , L    
00260       INTEGER  GRPX(NN) , GRPY(NN) , TMX(PP2) , TABLE(TT,PP2) , N , P 
00270                  .
00280                  .
00290                  .
00300 C     ----------------------------------------------------------------  
00310 C     -------------------   SET CELL INDEX METHOD   ------------------  
00320 C     ----------------------------------------------------------------  
00330 C                                               --- MAKE P*P CELLS ---  
00340       CALL CELLSET( N , NDENS , L , RCOFF )                            
00350 C                                        --- SET INITIAL POSITIONS ---
00360       CALL INIPOSIT( N , NDENS , RCOFF , NP )                          
00370 C                                       --- CELL NAME OF PARTICLES ---
00380       CALL GROUP( N )                                                   
00390 C                                  --- PARTICLE NAMES OF EACH CELL ---  
00400       CALL TABLECAL( N , P )                                            
00410                  .
00420                  .
00430                  .
00440       STOP
00450       END
00460 C*********************************************************************  
00470 C   THIS SUBROUTINE IS FOR DISTRIBUTING A MAIN CELL INTO             *
00480 C   MANY SUB-CELLS.                                                  *
00490 C*********************************************************************
00500 C**** SUB CELLSET ****                                                 
00510       SUBROUTINE CELLSET( N ,NDENS , L , RCOFF )                       
00520 C                                                                       
00530       IMPLICIT REAL*8 (A-H,O-Z)                                         
00540 C                                                                       
00550       COMMON /BLOCK6/  P   , GRPLX                                      
00560 C                                                                       
00570       INTEGER  PP                                                       
00580       PARAMETER( PP=15 )                                                
00590 C                                                                       
00600       INTEGER  P                                                        
00610       REAL*8   GRPLX(PP) , NDENS , L , C0                               
00620 C                                                                       
00630       L =  DSQRT( DBLE(N)/NDENS )                                       
00640       P = INT(L/RCOFF)                                                  
00650       IF(P .LE. 2) PAUSE                                                
00660 C                                                                       
00670       C0 = L/DBLE(P)                                                    
00680       DO 10 I=1,P                                                       
00690         GRPLX(I) = C0*DBLE(I)                                           
00700    10 CONTINUE                                                          
00710       RETURN   
00720       END      
00730 C*********************************************************************  
00740 C   THIS SUBROUTINE IS FOR CHECKING THE SUB-CELL TO WHICH EACH       *
00750 C   PARTICLE BELONGS.                                                *
00760 C*********************************************************************
00770 C**** SUB GROUP *****                                                   
00780       SUBROUTINE GROUP( N )                                             
00790 C                                                                       
00800       IMPLICIT REAL*8 (A-H,O-Z)                                         
00810 C                                                                       
00820       COMMON /BLOCK1/  RX , RY                                          
00830       COMMON /BLOCK3/  GRPX, GRPY                                       
00840       COMMON /BLOCK6/  P   , GRPLX                                      
00850 C                                                                       
00860       INTEGER  NN , PP                                                  
00870       PARAMETER( NN=1000 , PP=15 )                                      
00880 C                                                                       
00890       INTEGER  GRPX(NN) , GRPY(NN) , N      , P                         
00900       REAL*8   RX(NN)   , RY(NN)   , GRPLX(PP)                          
00910 C                                                                       
00920       DO 30 I=1,N                                                       
00930 C                                                  ----- X AXIS -----   
00940         DO 10 J=1,P                                                     
00950           IF( GRPLX(J) .GT. RX(I) ) THEN                                
00960             GRPX(I) = J                                                 
00970             GOTO 15                                                     
00980           END IF                                                        
00990    10   CONTINUE                                                        
01000         GRPX(I) = P                                                     
01010 C                                                  ----- Y AXIS -----   
01020    15   DO 20 J=1,P                                                     
01030           IF( GRPLX(J) .GT. RY(I) ) THEN                                
01040             GRPY(I) = J                                                 
01050             GOTO 30                                                     
01060           END IF                                                        
01070    20   CONTINUE                                                        
01080         GRPY(I) = P                                                     
01090 C                                                                       
01100    30 CONTINUE                                                          
01110       RETURN   
01120       END      
01130 C*********************************************************************  
01140 C   THIS SUBROUTINE IS FOR CHECKING THE PARTICLE NAMES WHICH EACH    *
01150 C   SUB-CELL HAS.                                                    *
01160 C*********************************************************************
01170 C**** SUB TABLECAL *****                                                
01180       SUBROUTINE TABLECAL( N , P )                                      
01190 C                                                                       
01200       IMPLICIT REAL*8 (A-H,O-Z)                                         
01210 C                                                                       
01220       COMMON /BLOCK3/  GRPX, GRPY                                       
01230       COMMON /BLOCK5/  TMX , TABLE                                      
01240 C                                                                       
01250       INTEGER  NN , PP2 , TT                                            
01260       PARAMETER( NN=1000 , PP2=225 , TT=500  )                          
01270 C                                                                       
01280       INTEGER  GRPX(NN) , GRPY(NN) , TMX(PP2) , TABLE(TT,PP2) 
01290       INTEGER  N   , P  , GX  , GY , GP     
01300 C                                                                       
01310       DO 10 GY=1,P                                                      
01320       DO 10 GX=1,P                                                      
01330         GP = GX + (GY-1)*P                                              
01340         TMX(GP)     = 0                                                 
01350         TABLE(1,GP) = 0                                                 
01360    10 CONTINUE                                                          
01370 C                                                                       
01380       DO 20 I=1,N                                                       
01390         GX = GRPX(I)                                                    
01400         GY = GRPY(I)                                                    
01410         GP = GX + (GY-1)*P                                              
01420         TMX(GP) = TMX(GP) + 1                                           
01430         TABLE( TMX(GP),GP ) = I                                         
01440    20 CONTINUE                                                          
01450       RETURN   
01460       END      


A5.6 ͂̌vZ (SUBROUTINE FORCECAL)

00010 C*********************************************************************  
00020 C   THIS SUBROUTINE IS FOR CALCULATING FORCES BETWEEN PARTICLES      *
00030 C   FOR THREE-DIMENSIONAL LENNARD-JONES SYSTEM.                      *  
00040 C      RCOFF2 = RCOFF**2                                             * 
00050 C*********************************************************************
00060 C**** SUB FORCECAL *****                                               
00070       SUBROUTINE FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX, FY, FZ )   
00080 C                                                                       
00090       IMPLICIT REAL*8( A-H , O-Z )                                      
00100 C                                                                       
00110       COMMON /BLOCK8/ XL    , YL     , ZL                               
00120 C                                                                       
00130       PARAMETER( NN=2050 )                                              
00140 C                                                                       
00150       INTEGER  N                                                        
00160       REAL*8   RX(NN)  , RY(NN)  , RZ(NN) , FX(NN) , FY(NN) , FZ(NN)    
00170 C                                                                       
00180       REAL*8   RXI  , RYI  , RZI  , RXIJ , RYIJ , RZIJ , RIJSQ          
00190       REAL*8   FXI  , FYI  , FZI  , FXIJ , FYIJ , FZIJ , FIJ            
00200       REAL*8   SR2  , SR6  , SR12                                       
00210 C                                                                       
00220       DO 10 I=1,N                                                       
00230         FX(I) = 0.D0                                                    
00240         FY(I) = 0.D0                                                    
00250         FZ(I) = 0.D0                                                    
00260    10 CONTINUE                                                          
00270 C                                                                       
00280       DO 100 I=1,N-1                                                    
00290 C                                                                       
00300         RXI = RX(I)                                                     
00310         RYI = RY(I)                                                     
00320         RZI = RZ(I)                                                     
00330         FXI = FX(I)                                                     
00340         FYI = FY(I)                                                     
00350         FZI = FZ(I)                                                     
00360 C                                                                       
00370         DO 50 J=I+1,N                                                   
00380 C                                                                       
00390           RXIJ = RXI  - RX(J)                                           
00400           RXIJ = RXIJ - DNINT(RXIJ/XL)*XL                               
00410           IF( DABS(RXIJ) .GE. RCOFF )      GOTO 50                      
00420           RYIJ = RYI  - RY(J)                                           
00430           RYIJ = RYIJ - DNINT(RYIJ/YL)*YL                               
00440           IF( DABS(RYIJ) .GE. RCOFF )      GOTO 50                      
00450           RZIJ = RZI  - RZ(J)                                           
00460           RZIJ = RZIJ - DNINT(RZIJ/ZL)*ZL                               
00470           IF( DABS(RZIJ) .GE. RCOFF )      GOTO 50                      
00480 C                                                                       
00490           RIJSQ= RXIJ*RXIJ + RYIJ*RYIJ + RZIJ*RZIJ                      
00500           IF( RIJSQ .GE. RCOFF2 )          GOTO 50                      
00510 C                                                                       
00520           SR2  = 1.D0/RIJSQ                                             
00530           SR6  = SR2*SR2*SR2                                            
00540           SR12 = SR6*SR6                                                
00550           FIJ  = ( 2.D0*SR12 - SR6 )/RIJSQ                              
00560           FXIJ = FIJ*RXIJ                                               
00570           FYIJ = FIJ*RYIJ                                               
00580           FZIJ = FIJ*RZIJ                                               
00590           FXI  = FXI  + FXIJ                                            
00600           FYI  = FYI  + FYIJ                                            
00610           FZI  = FZI  + FZIJ                                            
00620 C                                                                       
00630           FX(J) = FX(J) - FXIJ                                          
00640           FY(J) = FY(J) - FYIJ                                          
00650           FZ(J) = FZ(J) - FZIJ                                          
00660 C                                                                       
00670    50   CONTINUE                                                        
00680 C                                                                       
00690         FX(I) = FXI                                                     
00700         FY(I) = FYI                                                     
00710         FZ(I) = FZI                                                     
00720 C                                                                       
00730   100 CONTINUE                                                          
00740 C                                                                       
00750       DO 120 I=1,N                                                      
00760         FX(I) = FX(I)*24.D0                                             
00770         FY(I) = FY(I)*24.D0                                             
00780         FZ(I) = FZ(I)*24.D0                                             
00790   120 CONTINUE                                                          
00800       RETURN  
00810       END     


A5.7 q͊wASY̎僋[`

A5.7.1 VerletASY

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS MAIN PART OF THE VERLET ALGORITHM.               *
00030 C*********************************************************************
00040 C     RX0(I),RY0(I),RZ0(I) : POSITION OF PARTICLE I AT PREVIOUS TIME 
00050 C     HSQ = H*H   ,  RCOFF2 = RCOFF**2                              
00060 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL                 
00070 C---------------------------------------------------------------------  
00080 C
00090 C     ----------------------------------------------------------------  
00100 C     ------------------    START OF MAIN LOOP    --------------------   
00110 C     ----------------------------------------------------------------  
00120       DO 1000 NTIME=1,NTIMEMX                                      
00130 C                                                                       
00140         DO 100 I=1,N                                                     
00150 C                                                                       
00160           RXI = 2.D0*RX(I) - RX0(I) + FX(I)*HSQ
00170           RYI = 2.D0*RY(I) - RY0(I) + FY(I)*HSQ
00180           RZI = 2.D0*RZ(I) - RZ0(I) + FZ(I)*HSQ
00190           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                        
00200           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                      
00210           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL  
00220 C
00230           RX0(I) = RX(I)                                         
00240           RY0(I) = RY(I)                                          
00250           RZ0(I) = RZ(I)                                              
00260           RX(I)  = RXI                                                 
00270           RY(I)  = RYI                                                 
00280           RZ(I)  = RZI                                                 
00290 C                                                                       
00300   100   CONTINUE           
00310 C
00320         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX, FY, FZ )
00330 C 
00340  1000 CONTINUE                                                          
00350 C     ---------------------------------------------------------------   
00360 C     ---------------------   END OF MAIN LOOP   --------------------   
00370 C     ---------------------------------------------------------------   


A5.7.2 Velocity VerletASY

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS MAIN PART OF THE VELOCITY VERLET ALGORITHM.      *
00030 C*********************************************************************
00040 C     H2 = H/2.D0  ,  HSQ = H*H  ,  RCOFF2 = RCOFF**2                 
00050 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL                
00060 C---------------------------------------------------------------------  
00070 C     
00080 C     ----------------------------------------------------------------
00090 C     ------------------    START OF MAIN LOOP    -------------------- 
00100 C     ---------------------------------------------------------------- 
00110       DO 1000 NTIME = 1,NTIMEMX                                         
00120 C                                                                       
00130         DO 100 I = 1,N                                                  
00140 C                                                                       
00150           RXI = RX(I) + H*VX(I) + HSQ*FX(I)/2.D0           
00160           RYI = RY(I) + H*VY(I) + HSQ*FY(I)/2.D0   
00170           RZI = RZ(I) + H*VZ(I) + HSQ*FZ(I)/2.D0     
00180           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                        
00190           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                        
00200           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                        
00210 C                                       --- PART (A) OF VELOCITIES ---  
00220           VX(I) = VX(I) + H2*FX(I)                                     
00230           VY(I) = VY(I) + H2*FY(I)                                     
00240           VZ(I) = VZ(I) + H2*FZ(I)                                     
00250 C                                                                       
00260           RX(I) = RXI                                                   
00270           RY(I) = RYI                                                   
00280           RZ(I) = RZI                                                   
00290 C                                                                       
00300   100   CONTINUE                                                        
00310 C                                                                       
00320         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX, FY, FZ )      
00330 C                                                                       
00340 C                                       --- PART (B) OF VELOCITIES ---  
00350         DO 120 I = 1,N                                                  
00360           VXI = VX(I) + H2*FX(I)                                       
00370           VYI = VY(I) + H2*FY(I)                                       
00380           VZI = VZ(I) + H2*FZ(I)                                       
00390           VX(I) = VXI                                                   
00400           VY(I) = VYI                                                   
00410           VZ(I) = VZI                                                   
00420   120   CONTINUE                                                        
00430 C                                                                       
00440  1000 CONTINUE                                                          
00450 C     ---------------------------------------------------------------   
00460 C     ---------------------   END OF MAIN LOOP   --------------------   
00470 C     ---------------------------------------------------------------


A5.7.3 LeapfrogASY

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS MAIN PART OF THE LEAPFROG ALGORITHM.             *
00030 C*********************************************************************
00040 C     RCOFF2 = RCOFF**2                 
00050 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL                 
00060 C---------------------------------------------------------------------  
00070 C                                                                       
00080 C     ----------------------------------------------------------------  
00090 C     ------------------    START OF MAIN LOOP    --------------------   
00100 C     ----------------------------------------------------------------   
00110       DO 1000 NTIME = 1,NTIMEMX                                         
00120 C                                                                       
00130         DO 100 I = 1,N                                                  
00140 C                                                                       
00150           VX(I) = VX(I) + H*FX(I)                                      
00160           VY(I) = VY(I) + H*FY(I)                                      
00170           VZ(I) = VZ(I) + H*FZ(I)                                      
00180 C                                                                       
00190           RXI = RX(I) + H*VX(I)                                         
00200           RYI = RY(I) + H*VY(I)                                         
00210           RZI = RZ(I) + H*VZ(I)                                         
00220           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                        
00230           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                        
00240           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                        
00250 C                                                                       
00260           RX(I) = RXI                                                   
00270           RY(I) = RYI                                                   
00280           RZ(I) = RZI                                                   
00290 C                                                                       
00300   100   CONTINUE                                                        
00310 C                                                                       
00320         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX, FY, FZ )      
00330 C                                                                       
00340  1000 CONTINUE                                                          
00350 C     ---------------------------------------------------------------   
00360 C     ---------------------   END OF MAIN LOOP   --------------------   
00370 C     ---------------------------------------------------------------   


A5.7.4 BeemanASY

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS MAIN PART OF THE BEEMAN ALGORITHM.               *
00030 C*********************************************************************
00040 C     FX1(I),FY1(I),FZ1(I) : FORCES ACTING ON PARTICLE I AT N-STEP      
00050 C     FX2(I),FY2(I),FZ2(I) : FORCES ACTING ON PARTICLE I AT (N+1)-STEP
00060 C     CR1 = 4.D0/6.D0  ,  CR2 = 1.D0/6.D0  ,  CV1 = 2.D0/6.D0         
00070 C     CV2 = 5.D0/6.D0  ,  CV3 = 1.D0/6.D0                             
00080 C     HSQ = H*H   ,  RCOFF2 = RCOFF**2                 
00090 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL                 
00100 C---------------------------------------------------------------------
00110 C
00120 C     ----------------------------------------------------------------  
00130 C     ------------------    START OF MAIN LOOP    --------------------  
00140 C     ----------------------------------------------------------------  
00150       DO 1000 NTIME = 1,NTIMEMX                                         
00160 C                                                                       
00170         DO 100 I = 1,N                                                  
00180 C                                                                       
00190           RXI = RX(I) + H*VX(I) + HSQ*( CR1*FX2(I) - CR2*FX1(I) ) 
00200           RYI = RY(I) + H*VY(I) + HSQ*( CR1*FY2(I) - CR2*FY1(I) )      
00210           RZI = RZ(I) + H*VZ(I) + HSQ*( CR1*FZ2(I) - CR2*FZ1(I) )   
00220           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                        
00230           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                        
00240           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                        
00250 C                                       --- PART (A) OF VELOCITIES ---  
00260           VX(I) = VX(I) + H*( CV2*FX2(I) - CV3*FX1(I) )                 
00270           VY(I) = VY(I) + H*( CV2*FY2(I) - CV3*FY1(I) )                 
00280           VZ(I) = VZ(I) + H*( CV2*FZ2(I) - CV3*FZ1(I) )                 
00290 C                                                                       
00300           RX(I) = RXI                                                   
00310           RY(I) = RYI                                                   
00320           RZ(I) = RZI                                                   
00330           FX1(I) = FX2(I)                                               
00340           FY1(I) = FY2(I)                                               
00350           FZ1(I) = FZ2(I)                                               
00360 C                                                                       
00370   100   CONTINUE                                                        
00380 C                                                                       
00390         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX2, FY2, FZ2 )    
00400 C                                                                       
00410 C                                       --- PART (B) OF VELOCITIES ---  
00420         DO 120 I = 1,N                                                  
00430           VXI = VX(I) + H*CV1*FX2(I)                                    
00440           VYI = VY(I) + H*CV1*FY2(I)                                    
00450           VZI = VZ(I) + H*CV1*FZ2(I)                                    
00460           VX(I) = VXI                                                   
00470           VY(I) = VYI                                                   
00480           VZ(I) = VZI                                                   
00490   120   CONTINUE                                                        
00500 C                                                                       
00510  1000 CONTINUE                                                          
00520 C     ---------------------------------------------------------------   
00530 C     ---------------------   END OF MAIN LOOP   --------------------   
00540 C     ---------------------------------------------------------------   


A5.7.5 GearASY

00010 C*********************************************************************
00020 C*  THIS PROGRAM IS MAIN PART OF THE GEAR ALGORITHM.                 *
00030 C*********************************************************************
00040 C     BX( I),BY( I),BZ( I) : DERIVATIVE OF FORCES                       
00050 C     FX1(I),FY1(I),FZ1(I) : FORCES ACTING ON PARTICLE I AT N-STEP      
00060 C     FX2(I),FY2(I),FZ2(I) : FORCES ACTING ON PARTICLE I AT (N+1)-STEP
00070 C     CB0 = 1.D0/6.D0  ,  CB1 = 5.D0/6.D0    ,  CB2 = 1.D0            
00080 C     CB3 = 1.D0/3.D0                                                   
00090 C     CBB0  = CB0*HSQ2 ,  CBB1  = CB1*H/2.D0 ,  CBB2  = CB2           
00100 C     CBB3  = CB3*3.D0/H                                              
00110 C     HSQ2 = H*H/2.D0  ,  HTR6 = H*H*H/6.D0  ,  RCOFF2 = RCOFF**2     
00120 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL                 
00130 C---------------------------------------------------------------------  
00140 C
00150 C     ----------------------------------------------------------------  
00160 C     ------------------    START OF MAIN LOOP    --------------------  
00170 C     ----------------------------------------------------------------  
00180       DO 1000 NTIME = 1,NTIMEMX                                         
00190 C                                                                       
00200         DO 100 I = 1,N                                                  
00210 C                                                   --- PREDICTION ---  
00220 C                                                                       
00230           RXI = RX(I) + H*VX(I) + HSQ2*FX1(I) + HTR6*BX(I)              
00240           RYI = RY(I) + H*VY(I) + HSQ2*FY1(I) + HTR6*BY(I)              
00250           RZI = RZ(I) + H*VZ(I) + HSQ2*FZ1(I) + HTR6*BZ(I)              
00260           RX(I) = RXI - DNINT( RXI/XL - 0.5D0 )*XL                      
00270           RY(I) = RYI - DNINT( RYI/YL - 0.5D0 )*YL                      
00280           RZ(I) = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                      
00290 C                                                                       
00300           VX(I) = VX(I) + H*FX1(I) + HSQ2*BX(I)                         
00310           VY(I) = VY(I) + H*FY1(I) + HSQ2*BY(I)                         
00320           VZ(I) = VZ(I) + H*FZ1(I) + HSQ2*BZ(I)                         
00330 C                                                                       
00340           FX1(I) = FX1(I) + H*BX(I)                                     
00350           FY1(I) = FY1(I) + H*BY(I)                                     
00360           FZ1(I) = FZ1(I) + H*BZ(I)                                     
00370 C                                                                       
00380   100   CONTINUE                                                        
00390 C                                                                       
00400         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX2, FY2, FZ2 )    
00410 C                                                                       
00420 C                                                   --- CORRECTION ---  
00430         DO 110 I = 1,N                                                  
00440           DAX = FX2(I) - FX1(I)                                         
00450           DAY = FY2(I) - FY1(I)                                         
00460           DAZ = FZ2(I) - FZ1(I)                                         
00470 C                                                                       
00480           RX(I) = RX(I) + CBB0*DAX                                      
00490           RY(I) = RY(I) + CBB0*DAY                                      
00500           RZ(I) = RZ(I) + CBB0*DAZ                                      
00510 C                                                                       
00520           VX(I) = VX(I) + CBB1*DAX                                      
00530           VY(I) = VY(I) + CBB1*DAY                                      
00540           VZ(I) = VZ(I) + CBB1*DAZ                                      
00550 C                                                                       
00560           FX1(I) = FX2(I)                                               
00570           FY1(I) = FY2(I)                                               
00580           FZ1(I) = FZ2(I)                                               
00590 C                                                                       
00600           BX(I) = BX(I) + CBB3*DAX                                      
00610           BY(I) = BY(I) + CBB3*DAY                                      
00620           BZ(I) = BZ(I) + CBB3*DAZ                                      
00630   110   CONTINUE                                                        
00640 C                                                                       
00650  1000 CONTINUE                                                          
00660 C     ---------------------------------------------------------------   
00670 C     ---------------------   END OF MAIN LOOP   --------------------   
00680 C     ---------------------------------------------------------------   


A5.8 q͊wASŸ萫̌vO (MDSTAB2C.FORT)

00010 C********************************************************************* 
00020 C*                                                                   * 
00030 C*              MDSTAB2C.FORT                                        * 
00040 C*                                                                   *
00050 C*     --------------------------------------------------------      *
00060 C*     -  NVE MOLECULAR DYNAMICS SIMULATION FOR               -      * 
00070 C*     -  THREE-DIMENSIONAL LENNARD-JONES SYSTEM.             -      *
00080 C*     --------------------------------------------------------      * 
00090 C*              1. VELOCITY VERLET ALGORITHM                         * 
00100 C*              2. INVESTIGATION OF STABILITY ACCORDING              * 
00110 C*                 TO TIME INTERVALS                                 * 
00120 C*              3. NOT USING THE CELL INDEX METHOD                   * 
00130 C*                                                                   * 
00140 C*        COMMAND PROC. (FOR HITAC-VOS3)                             * 
00150 C*              10 ALLOC DD(FT09F001) DS(ZZ.DATA)  REN REU           * 
00160 C*              20 ALLOC DD(FT15F001) DS(ZZ1.DATA) REN REU           * 
00170 C*              30 RUN MDSTAB2C.FORT                                 * 
00180 C*              40 FREE ALL                                          * 
00190 C*              50 END                                               * 
00200 C*                            ZZ.DATA  : DATA OF VEL**2              * 
00210 C*                            ZZ1.DATA : DATA OF VEL**2 FOR DRAFT    * 
00220 C*                                                                   * 
00230 C*                                    VER.1 BY A.SATOH , '94  5/12   * 
00240 C********************************************************************* 
00250 C     FX1(I),FY1(I),FZ1(I) : FORCES ACTING ON PARTICLE I          
00260 C     NDENS0      : NUMBER DENSITY                                     
00270 C     TEMP0       : TEMPERATURE (DESIRED)                              
00280 C     VELSQAV(NS) : ACTUAL INSTANT TEMPERATURE IN SIMULATIONS          
00290 C                   AT EACH TIME STEP                              
00300 C     TMPMIDAV(NS): MEAN TEMPERATURE OBTAINED BY USING SOME RESULTS    
00310 C     NTIMEMX     : MAXIMUM NUMBER OF TIME STEP 
00320 C     0<RX(I)<XL  ,  0<RY(I)<YL  ,  0<RZ(I)<ZL
00330 C--------------------------------------------------------------------- 
00340       IMPLICIT REAL*8 (A-H,O-Z)                                        
00350 C                                                                      
00360       COMMON /BLOCK1/ RX     , RY     , RZ                             
00370       COMMON /BLOCK3/ VX     , VY     , VZ                             
00380       COMMON /BLOCK4/ FX1    , FY1    , FZ1                            
00390       COMMON /BLOCK7/ N      , NDENS0 , TEMP0                          
00400       COMMON /BLOCK8/ XL     , YL     , ZL                             
00410       COMMON /BLOCK9/ VELSQAV, TMPMIDAV                                
00420       COMMON /BLOCK20/NRAN   , RAN  , IX                               
00430 C                                                                      
00440       PARAMETER( NN=2050 , NS=300000 )                                 
00450       PARAMETER( NRANMX=100000 , PI=3.141592653589793D0 )              
00460 C                                                                      
00470       INTEGER  N                                                       
00480       REAL*8   RX(NN), RY(NN), RZ(NN) , VX(NN), VY(NN), VZ(NN)
00490       REAL*8   FX1(NN), FY1(NN), FZ1(NN)
00500       REAL*8   VELSQAV(NS) , TMPMIDAV(NS) , NDENS0      
00510 C                                                                      
00520       REAL     RAN(NRANMX)                                             
00530       INTEGER  NRAN   , IX                                             
00540 C                                                                      
00550       REAL*8   H  , HSQ  , H2 , RCOFF , RCOFF2                         
00560       REAL*8   EH , EHSQ , EH2                                         
00570       REAL*8   RXI  , RYI , RZI  , VXI , VYI , VZI , VELSQ             
00580       REAL*8   EVELX, EVELY, EVELZ, EVELSQ                             
00590       INTEGER  NTIME  , NTIMEMX  , DN , SMPL                           
00600       INTEGER  ENTIME , ENTIMEMX                                       
00610       INTEGER  NVELSC , NTMPMID  , NTMPMX , NP                         
00620       LOGICAL  STABLE                                                  
00630 C                                                                      
00640                                                                  NP=9  
00650                  OPEN( 9,FILE='ZZ.DATA' ,STATUS='UNKNOWN',TYPE='TEXT') 
00660                  OPEN(15,FILE='ZZ1.DATA',STATUS='UNKNOWN',TYPE='TEXT') 
00670 C
00680 C                                                                      
00690 C                                            ----- PARAMETER (1) ----- 
00700 C                                                                      
00710 C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
00720 C         N=32, 108, 256, 500, 864, 1372, 2048 MUST BE CHOSEN.         
00730 C                                                                      
00740 C            H       NTIMEMX   DN           H       NTIMEMX   DN       
00750 C          0.01       10,000    1         0.001     100,000   10       
00760 C          0.009      11,000    1         0.0009    110,000   11       
00770 C          0.008      12,000    1         0.0008    120,000   12       
00780 C          0.007      14,000    1         0.0007    140,000   14       
00790 C          0.006      17,000    1         0.0006    170,000   17       
00800 C          0.005      20,000    2         0.0005    200,000   20       
00810 C          0.004      25,000    2         0.0004    250,000   25       
00820 C          0.003      33,000    3         0.0003    330,000   33       
00830 C          0.002      50,000    5         0.0002    500,000   50       
00840 C                                         0.0001  1,000,000  100       
00850 C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
00860       N     = 108                                                      
00870       RCOFF = 2.5D0                                                    
00880       H     = 0.005D0                                                  
00890 C                                                                      
00900       NTIMEMX= 20000                                                   
00910       DN     = 2                                                       
00920 C                                                                      
00930       NDENS0= 0.2D0                                                    
00940       TEMP0 = 2.0D0                                                    
00950 C                                                                      
00960       NTMPMID = INT( (0.2D0 + 1.D-10) /H )                             
00970 C                                            ----- PARAMETER (2) ----- 
00980       H2      = H/2.D0                                                 
00990       HSQ     = H*H                                                    
01000       RCOFF2  = RCOFF**2                                               
01010       DT      = H*DBLE(DN)                                             
01020 C                                            ----- PARAMETER (3) ----- 
01030       EH      = H                                                      
01040       ENTIMEMX= 1000                                                   
01050       NVELSC  = INT( 0.2D0/H )                                         
01060       IF( NVELSC .LE. 5 ) THEN                                         
01070         NVELSC = 5                                                     
01080       ELSE IF( (NVELSC.GT.5) .AND. (NVELSC.LE.10) ) THEN               
01090         NVELSC = 10                                                    
01100       ELSE IF( (NVELSC.GT.10).AND. (NVELSC.LE.20) ) THEN               
01110         NVELSC = 20                                                    
01120       ELSE IF( (NVELSC.GT.20).AND. (NVELSC.LE.40) ) THEN               
01130         NVELSC = 40                                                    
01140       ELSE                                                             
01150         NVELSC = 50                                                    
01160       END IF                                                           
01170       EH2     = EH/2.D0                                                
01180       EHSQ    = EH*EH                                                  
01190 CCC   EH      = 0.0001D0                                               
01200 CCC   ENTIMEMX= 5000                                                   
01210 CCC   NVELSC  = 500                                                    
01220 C                                            ----- PARAMETER (5) ----- 
01230       IX      = 0                                                      
01240       CALL RANCAL( NRANMX,IX,RAN )                                     
01250       NRAN    = 1                                                      
01260 C                                                                      
01270 C     ---------------------------------------------------------------- 
01280 C     -----------------    INITIAL CONFIGURATION    ------------------ 
01290 C     ---------------------------------------------------------------- 
01300 C                                                                      
01310 C                                        --- SET INITIAL POSITIONS --- 
01320       CALL INIPOSIT( N, NDENS0, XL )                          
01330       YL = XL
01340       ZL = XL  
01350 C                                       --- SET INITIAL VELOCITIES --- 
01360       CALL INIVEL( N, TEMP0 )     
01370 C                                             --- CALCULATE ENERGY --- 
01380       CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX1, FY1, FZ1 ) 
01390 C                                                                      
01400 C                                          --- PRINT OUT CONSTANTS --- 
01410       WRITE(NP,10) N,NDENS0, TEMP0, RCOFF, H, XL, YL, ZL,              
01420      &             EH, ENTIMEMX, NTMPMID                               
01430 C                                                                      
01440 C                                                --- EQUILIBRATION --- 
01450       EVELX  = 0.D0                                                    
01460       EVELY  = 0.D0                                                    
01470       EVELZ  = 0.D0                                                    
01480       EVELSQ = 0.D0                                                    
01490 C                                                                      
01500       DO 50 ENTIME = 1, ENTIMEMX                                       
01510 C                                                                      
01520         DO 45 I = 1,N                                                  
01530 C                                                                      
01540 C                                                                      
01550           RXI = RX(I) + EH*VX(I) + EHSQ*FX1(I)/2.D0      
01560           RYI = RY(I) + EH*VY(I) + EHSQ*FY1(I)/2.D0 
01570           RZI = RZ(I) + EH*VZ(I) + EHSQ*FZ1(I)/2.D0 
01580 C                                                                      
01590           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                       
01600           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                       
01610           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                       
01620 C                                       --- PART (A) OF VELOCITIES --- 
01630           VX(I) = VX(I) + EH2*FX1(I)                                   
01640           VY(I) = VY(I) + EH2*FY1(I)                                   
01650           VZ(I) = VZ(I) + EH2*FZ1(I)                                   
01660 C                                                                      
01670           RX(I) = RXI                                                  
01680           RY(I) = RYI                                                  
01690           RZ(I) = RZI                                                  
01700 C                                                                      
01710    45   CONTINUE                                                       
01720 C                                                                      
01730         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX1, FY1, FZ1 )  
01740 C                                                                      
01750 C                                       --- PART (B) OF VELOCITIES --- 
01760         DO 47 I = 1,N                                                  
01770           VXI = VX(I) + EH2*FX1(I)                                     
01780           VYI = VY(I) + EH2*FY1(I)                                     
01790           VZI = VZ(I) + EH2*FZ1(I)                                     
01800           VX(I) = VXI                                                  
01810           VY(I) = VYI                                                  
01820           VZ(I) = VZI                                                  
01830           EVELX = EVELX + VXI                                          
01840           EVELY = EVELY + VYI                                          
01850           EVELZ = EVELZ + VZI                                          
01860           EVELSQ  = EVELSQ + VXI*VXI + VYI*VYI + VZI*VZI               
01870    47   CONTINUE                                                       
01880 C                                             --- VELOCITY SCALING --- 
01890         IF( MOD(ENTIME,NVELSC) .EQ. 0 ) THEN                           
01900           EVELX  = EVELX /DBLE(N*NVELSC)                               
01910           EVELY  = EVELY /DBLE(N*NVELSC)                               
01920           EVELZ  = EVELZ /DBLE(N*NVELSC)                               
01930           EVELSQ = EVELSQ/DBLE(N*NVELSC)                               
01940           CALL SCALEVEL( N, TEMP0, EVELX, EVELY, EVELZ, EVELSQ )       
01950           EVELX  = 0.D0                                                
01960           EVELY  = 0.D0                                                
01970           EVELZ  = 0.D0                                                
01980           EVELSQ = 0.D0                                                
01990         END IF                                                         
02000 C                                                                      
02010    50 CONTINUE                                                         
02020 C                                --- PRINT OUT INSTANT TEMPERATURE --- 
02030       EVELSQ = 0.D0                                                    
02040       DO 52 I = 1,N                                                    
02050         VXI = VX(I)                                                    
02060         VYI = VY(I)                                                    
02070         VZI = VZ(I)                                                    
02080         EVELSQ  = EVELSQ + VXI*VXI + VYI*VYI + VZI*VZI                 
02090    52 CONTINUE                                                         
02100       EVELSQ = EVELSQ/DBLE(3*N)                                        
02110       WRITE(NP,53) EVELSQ                                              
02120 C                                                                      
02130 C     ---------------------------------------------------------------- 
02140 C     ------------------    START OF MAIN LOOP    --------------------  
02150 C     ----------------------------------------------------------------  
02160       SMPL = 0                                                         
02170       DO 70 I=1,NTIMEMX                                                
02180         TMPMIDAV(I) = 0.D0                                             
02190    70 CONTINUE                                                         
02200 C                                                                      
02210 C                                                                      
02220       DO 1000 NTIME = 1,NTIMEMX                                        
02230 C                                                                      
02240 C                                                                      
02250         DO 100 I = 1,N                                                 
02260 C                                                                      
02270           RXI = RX(I) + H*VX(I) + HSQ*FX1(I)/2.D0  
02280           RYI = RY(I) + H*VY(I) + HSQ*FY1(I)/2.D0  
02290           RZI = RZ(I) + H*VZ(I) + HSQ*FZ1(I)/2.D0  
02300           RXI = RXI - DNINT( RXI/XL - 0.5D0 )*XL                       
02310           RYI = RYI - DNINT( RYI/YL - 0.5D0 )*YL                       
02320           RZI = RZI - DNINT( RZI/ZL - 0.5D0 )*ZL                       
02330 C                                       --- PART (A) OF VELOCITIES --- 
02340           VX(I) = VX(I) + H2*FX1(I)                                    
02350           VY(I) = VY(I) + H2*FY1(I)                                    
02360           VZ(I) = VZ(I) + H2*FZ1(I)                                    
02370 C                                                                      
02380           RX(I) = RXI                                                  
02390           RY(I) = RYI                                                  
02400           RZ(I) = RZI                                                  
02410 C                                                                      
02420   100   CONTINUE                                                       
02430 C                                                                      
02440         CALL FORCECAL( N, RCOFF, RCOFF2, RX, RY, RZ, FX1, FY1, FZ1 )  
02450 C                                                                      
02460 C                                       --- PART (B) OF VELOCITIES --- 
02470         DO 120 I = 1,N                                                 
02480           VXI = VX(I) + H2*FX1(I)                                      
02490           VYI = VY(I) + H2*FY1(I)                                      
02500           VZI = VZ(I) + H2*FZ1(I)                                      
02510           VX(I) = VXI                                                  
02520           VY(I) = VYI                                                  
02530           VZ(I) = VZI                                                  
02540   120   CONTINUE                                                       
02550 C                                                                      
02560 C       -------------------------------------------------------------- 
02570 C                                                                      
02580         IF( MOD(NTIME,DN) .EQ. 0 ) THEN                                
02590           VELSQ = 0.D0                                                 
02600           DO 130 I=1,N                                                 
02610             VXI = VX(I)                                                
02620             VYI = VY(I)                                                
02630             VZI = VZ(I)                                                
02640             VELSQ  = VELSQ + VXI*VXI + VYI*VYI + VZI*VZI               
02650   130     CONTINUE                                                     
02660           VELSQ = VELSQ/DBLE(N)                                        
02670           SMPL  = SMPL + 1                                             
02680           VELSQAV(SMPL)= VELSQ                                         
02690         END IF                                                         
02700 C                                                                      
02710         VELSQ = 0.D0                                                   
02720         DO 140 I=1,N                                                   
02730           VXI = VX(I)                                                  
02740           VYI = VY(I)                                                  
02750           VZI = VZ(I)                                                  
02760           VELSQ  = VELSQ + VXI*VXI + VYI*VYI + VZI*VZI                 
02770   140   CONTINUE                                                       
02780         VELSQ = VELSQ/DBLE(3*N)                                        
02790         II    = ( NTIME + NTMPMID - 1 )/NTMPMID                        
02800         TMPMIDAV(II) = TMPMIDAV(II) + VELSQ                            
02810         NTMPMX       = II                                              
02820 C                                                                      
02830         IF( MOD(NTIME,NTMPMID) .EQ. 0 ) THEN                           
02840           VELSQ        = TMPMIDAV(II)/DBLE(NTMPMID)                    
02850           TMPMIDAV(II) = VELSQ                                         
02860           IF( (VELSQ .GT. 1.3D0*TEMP0) .OR.                            
02870      &        (VELSQ .LT. 0.7D0*TEMP0)      ) THEN                     
02880             STABLE = .FALSE.                                           
02890             NTMPMX = II                                                
02900             GOTO 1100                                                  
02910           END IF                                                       
02920         END IF                                                         
02930 C                                                                      
02940 C                                                                      
02950  1000 CONTINUE                                                         
02960 C                                                                      
02970 C     ---------------------------------------------------------------  
02980 C     ---------------------   END OF MAIN LOOP   --------------------  
02990 C     ---------------------------------------------------------------  
03000 C                                                                      
03010       STABLE = .TRUE.                                                  
03020       WRITE(NP,*)' SYSTEM IS STABLE ********************************'  
03030 C                                                   --- PRINT OUT ---  
03040  1100 IF( STABLE ) THEN                                                
03050         WRITE(NP,1102) ( VELSQAV(I),I=1,SMPL,10)                       
03060       ELSE                                                             
03070         IF( SMPL .GT. 1000 ) THEN                                      
03080           WRITE(NP,1104) ( VELSQAV(I),I=SMPL-1000,SMPL )               
03090         ELSE                                                           
03100           WRITE(NP,1106) ( VELSQAV(I),I=1,SMPL )                       
03110         END IF                                                         
03120       END IF                                                           
03130 C                                                                      
03140       WRITE(NP,1107) ( TMPMIDAV(I),I=1,NTMPMX )                        
03150 C                                                                      
03160       IF( STABLE ) THEN                                                
03170         WRITE(NP,1108) DT*DBLE(SMPL)                                   
03180       ELSE                                                             
03190         WRITE(NP,1109) DT*DBLE(SMPL)                                   
03200       END IF                                                           
03210 C                                                 --- DATA OUTPUT ---  
03220       WRITE(15,1114) SMPL, DT, H, DN, NTMPMX                           
03230       WRITE(15,1116) ( VELSQAV(I),I=1,SMPL )                           
03240       WRITE(15,1118) N, NDENS0, TEMP0, RCOFF                           
03250       WRITE(15,1116) ( TMPMIDAV(I),I=1,NTMPMX )                        
03260 C                                                                      
03270 C                                                                      
03280                                   CLOSE( 9,STATUS='KEEP')              
03290                                   CLOSE(15,STATUS='KEEP')              
03300 C                                                                      
03310 C     ------------------------- FORMAT ------------------------------- 
03320 C                                                                      
03330    10 FORMAT(/1H ,'------------------------------------------------'   
03340      &       /1H ,'       MOLECULAR DYNAMICS METHOD                '   
03350      &       /1H ,'      +++ THREE-DIMENSIONAL CASE +++            '   
03360      &      //1H ,'N=',I4 ,3X, 'NDENS=',F8.3 ,3X, 'TEMP=',F6.3 ,3X,    
03370      &            'RCOFF=',F6.3 ,3X, 'H=',F10.8                        
03380      &       /1H ,'XL=',F6.3 ,3X, 'YL=',F6.3, 3X,'ZL=',F6.3            
03390      &       /1H ,'EH=',F10.8 ,3X, 'ENTIMEMX=',I8                      
03400      &       /1H ,'NTMPMID=',I8                                        
03410      &      //1H ,'------------------------------------------------'/) 
03420    53 FORMAT(/1H ,'*** INSTANT TEMPERATURE AFTER EQUILIBRATION ***'    
03430      &           ,'   TEMP=',F7.3/)                                    
03440  1102 FORMAT(/1H ,'+++++ VELSQ(1), VELSQ(11), VELSQ(21), ....... ++++' 
03450      &       /(1H ,2X, 10F7.2) )                                       
03460  1104 FORMAT(/1H ,'+++++ ......... , VELSQ(SMPL-1), VELSQ(SMPL) +++++' 
03470      &       /(1H ,2X, 10F7.2) )                                       
03480  1106 FORMAT(/1H ,'+++++ VELSQ(1), VELSQ(2), ...... ,VELSQ(SMPL) ++++' 
03490      &       /(1H ,2X, 10F7.2) )                                       
03500  1107 FORMAT(/1H ,'+++++ TMPMIDAV(1), TMPMIDAV(2),.............. ++++' 
03510      &       /(1H ,2X, 10F7.2) )                                       
03520  1108 FORMAT(/1H ,'++++ SYSTEM IS STABLE ++++      TIME=',F11.5/)      
03530  1109 FORMAT(/1H ,'---- NOT STABLE ----------      TIME=',F11.5/)      
03540  1114 FORMAT( I8 , 2E18.10 , 2I8 )                                     
03550  1116 FORMAT( (10F8.3) )                                               
03560  1118 FORMAT( I8 , 3E18.10 )                                           
03570       STOP  
03580       END   
